Available in🇮🇳 India
1. Create an Authorisation Transaction
Authorisation transaction + auto-charge first paymentYou can register a customer’s mandate AND charge them the first recurring payment as part of the same transaction. To do this all you have to do is pass the
first_payment_amount parameter while creating the order.1.1. Using Razorpay APIs
To create an authorisation transaction using the Razorpay APIs, you need to:1.1.1. Create a Customer
Razorpay links recurring tokens to customers using a unique identifier generated through the Customer API. You can create customers with basic information such asemail and contact and use them for various Razorpay offerings. The following endpoint creates a customer.
POST /customers
Sample Code
Sample Code
Request Parameters
name
: string The name of the customer. For example, Gaurav Kumar.
email
: string The email address of the customer. For example, gaurav.kumar@example.com.
contact
: string The phone number of the customer. For example, 9876543210.
fail_existing optional
: string The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter fail_existing to get the existing customer’s details in the response. Possible values:
1(default): If a customer with the same details already exists, throws an error.0: If a customer with the same details already exists, fetches details of the existing customer.
notes optional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
1.1.2. Create an Order
Use the Orders API to create a unique Razorpayorder_id that is associated with the authorisation transaction. The following endpoint creates an order.
POST /orders
Emandate via Netbanking
Given below is the sample code to authenticate emandate with Netbanking.Emandate via Debit Card
Given below is the sample code to authenticate emandate with debit card.Emandate via Aadhaar
Given below is the sample code to authenticate emandate with Aadhaar.Request Parameters
amount mandatory
: integer Amount in currency subunits. For emandate, the amount should be 0.
currency mandatory
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
payment_capture mandatory
: boolean Determines whether the payment status should be changed to captured automatically or not. Possible values:
true: Payments are captured automatically.false: Payments are not captured automatically. You can manually capture payments using the Manually Capture Payments API.
method mandatory
: string The authorisation method. Here, it is emandate.
customer_id mandatory
: string The unique identifier of the customer to be charged. For example, cust_D0cs04OIpPPU1F.
receipt optional
: string A user-entered unique identifier of the order. For example, rcptid #1. You should map this parameter to the order_id sent by Razorpay.
notesoptional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
token
: object Details related to the authorisation such as max amount and bank account information. Pass a value in the first_payment_amount parameter if you want to auto-charge the customer the first payment immediately after authorisation using the same order_id. The first payment will be created automatically and executed within 2 days of emandate token confirmation.
first_payment_amount optional
: integer The amount, in paise, that should be auto-charged in addition to the authorization amount. For example, 100000.
auth_type optional
: string Emandate type used to make the authorisation payment. Possible values:
netbankingdebitcardaadhaar
max_amount optional
: integer The maximum amount in paise a customer can be charged in a transaction. Know about the maximum and default values.
expire_at optional
: integer The Unix timestamp to indicate till when you can use the token (authorisation on the payment method) to charge the customer subsequent payments. Defaults to 40 years. The maximum value you can set is 40 years from the current date. Any value beyond this will throw an error.
notesoptional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
bank_account
: Customer’s bank account details that should be pre-filled on the checkout.
account_number optional
: string Customer’s bank account number.
account_type optional
: string Customer’s bank account type. Possible values:
savings(default)current
ifsc_code optional
: string Customer’s bank IFSC. For example UTIB0000001.
beneficiary_name optional
: string Name of the beneficiary. For example, Gaurav Kumar.
1.1.3. Create an Authorisation Payment
Once an order is created, your next step is to create a payment. Use the below endpoint to create a payment with payment methodnetbanking.
POST /payments/create/json
Request Parameters
amount mandatory
: integer Amount in currency subunits. For netbanking, the amount has to be 0 (₹0).
currency mandatory
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
order_id mandatory
: string The unique identifier of the order created using in Step 1.1.2.
customer_id mandatory
: string The unique identifier of the customer to be charged. For example, cust_K39wXdBlhqNk0B.
recurring mandatory
: boolean Possible values:
true: Recurring payment is enabled.false: Recurring payment is not enabled.
auth_type optional
: string Emandate type used to make the authorisation payment. Possible values:
netbankingdebitcardaadhaar
email mandatory
: string The customer’s email address. For example, gaurav.kumar@example.com.
contact mandatory
: string The customer’s contact number. For example, 8888888888.
method mandatory
: string The payment method selected by the customer. Here, the value must be emandate.
bank mandatory
: string The customer’s bank name. The bank code used here should match the bank details used in Step 1.1.2. Use the Method API to check the bank code.
account_number
: string Customer’s bank account number.
account_type
: string Customer’s bank account type. Possible values:
savings(default)current
ifsc_code
: string Customer’s bank IFSC. For example HDFC0000001.
Response Parameters
If the payment request is valid, the response contains the following fields. Refer to the S2S Json V2 integration document for more details.razorpay_payment_id
: string Unique identifier of the payment. Present for all responses.
next
: array A list of action objects available to you to continue the payment process. Present when the payment requires further processing.
action
: string An indication of the next step available to you to continue the payment process. The value here is redirect - Use this URL to redirect customer to the bank page.
url
: string URL to be used for the action indicated.
1.2. Using a Registration Link
Registration Links are an alternate way of creating an authorisation transaction. If you create a registration link, you need not create a customer or an order. When you create a registration link, an invoice is automatically issued to the customer. The customer can use the invoice to make the Authorisation Payment. Know how to create Registration Links using the Dashboard.Handy TipsYou can use webhooks to get notifications about successful payments against a registration link. Know more about Webhooks.
0.
1.2.1. Create a Registration Link
The following endpoint creates a registration link.POST /subscription_registration/auth_links
Emandate via Netbanking
Emandate via Debit Card
Emandate via Aadhaar
Request Parameters
customer
: object Details of the customer to whom the registration link is sent.
name mandatory
: string Customer’s name.
email mandatory
: string Customer’s email address.
contactmandatory
: integer Customer’s contact number.
type mandatory
: string In this case, the value is link.
amount mandatory
: integer The payment amount in the smallest currency sub-unit.
currency mandatory
: string The 3-letter ISO currency code for the payment.
description mandatory
: string A description that appears on the hosted page.
subscription_registration
: Details of the authorisation payment.
method mandatory
: string The authorization method. Here, it is emandate.
auth_type optional
: string Possible values:
netbankingdebitcardaadhaar
first_payment_amount optional
: integer The amount, in paise, the customer should be auto-charged in addition to the authorization amount. For example, 100000.
max_amount optional
: integer The maximum amount, in paise, a customer can be charged in a transaction. Know about maximum and default values.
expire_at optional
: integer The Unix timestamp indicates till when you can use the token (authorization on the payment method) to charge the customer their subsequent payments. Defaults to 40 years. The maximum value you can set is 40 years from the current date. Any value beyond this will throw an error.
bank_account
: The customer’s bank account details.
beneficiary_name optional
: string Name on the beneficiary. For example Gaurav Kumar.
account_number optional
: string Customer’s bank account number. For example 11214311215411.
account_type optional
: string Customer’s bank account type. Possible values:
savings(default)current
ifsc_code optional
: string Customer’s bank IFSC. For example HDFC0000001.
sms_notify optional
: boolean Indicates if SMS notifications are to be sent by Razorpay. Possible values:
true(default): Notifications are sent by Razorpay .false: Notifications are not sent by Razorpay.
email_notify optional
: boolean Indicates if email notifications are to be sent by Razorpay. Possible values:
true(default): Notifications are sent by Razorpay .false: Notifications are not sent by Razorpay.
expire_by optional
: integer The Unix timestamp indicates the expiry of the registration link.
receipt optional
: string A unique identifier entered by you for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.
notes optional
: object This is a key-value pair that is used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
1.2.2. Send/Resend Notifications
The following endpoint sends/resends notifications with the short URL to the customer:POST /invoices/:id/notify_by/:medium
Sample Code
Sample Code
Response
Path Parameters
idmandatory
: string The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, inv_1Aa00000000001.
medium mandatory
: string Determines through which medium you want to resend the notification. Possible values:
smsemail
1.2.3. Cancel a Registration Link
The following endpoint cancels a registration link.POST /invoices/:id/cancel
Handy TipsYou can only cancel registration link in the
issued state.Sample Code
Sample Code
Response
Path Parameter
id mandatory
: string The unique identifier for the invoice linked to the registration link that you want to cancel. For example, inv_1Aa00000000001.
2. Fetch and Manage Tokens
Once you capture a payment, Razorpay Checkout returns arazorpay_payment_id. You can use this id to fetch the token_id, which is used to create and charge subsequent payments.
You can retrieve the token_id using the Dashboard or the APIs given below.
2.1. Fetch Token by Payment ID
The following endpoint retrieves thetoken_id using a payment_id.
GET /payments/:id
Handy TipsYou can also retrieve the
token_id via the payment.authorized webhook.Path Parameter
id mandatory
: string The unique identifier of the payment to be retrieved. For example, pay_1Aa00000000002.
2.2. Fetch Tokens by Customer ID
A customer can have multiple tokens and these tokens can be used to create subsequent payments for multiple products or services. The following endpoint retrieves tokens linked to a customer.GET /customers/:id/tokens
Path Parameter
id mandatory
: string The unique identifier of the customer for whom tokens are to be retrieved. For example, cust_1Aa00000000002.
2.3. Delete Tokens
The following endpoint deletes a token.DELETE /customers/:customer_id/tokens/:token_id
Path Parameter
customer_id mandatory
: string The unique identifier of the customer with whom the token is linked. For example, cust_1Aa00000000002.
token_id mandatory
: string The unique identifier of the token that is to be deleted. For example, token_1Aa00000000001.
3. Create Subsequent Payments
You should perform the following steps to create and charge your customer subsequent payments:3.1. Create an Order to Charge the Customer
You have to create a new order every time you want to charge your customers. This order is different from the one created during the authorisation transaction. The following endpoint creates an order.POST /orders
3.2. Create a Recurring Payment
Once you have generated anorder_id, use it with the token_id to create a payment and charge the customer. The following endpoint creates a payment to charge the customer.
POST /payments/create/recurring
Request Parameters
email mandatory
: string The customer’s email address. For example, gaurav.kumar@example.com.
contact mandatory
: integer The customer’s phone number. For example, 9876543210.
currency mandatory
: string 3-letter ISO currency code for the payment. Currently, only INR is allowed.
amount mandatory
: integer The amount you want to charge your customer. This should be the same as the order amount.
order_idmandatory
: string The unique identifier of the order created. For example, order_1Aa00000000002.
customer_id mandatory
: string The unique identifier of the customer you want to charge. For example, cust_1Aa00000000002.
token mandatory
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.
recurring mandatory
: boolean Determines whether recurring payment is enabled or not.
true: Recurring payment is enabled.false: Recurring payment is not enabled.
descriptionoptional
: string A user-entered description for the payment. For example, Creating recurring payment for Gaurav Kumar
notesoptional
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.